
#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>

int write_newline;

int
main(int argc, char *argv[])
{

	int opt;
	int enabled_escapes;

	enabled_escapes = 0;
	write_newline = 1;
	opterr = 0;

	while ((opt = getopt(argc, argv, "neE")) != -1){
		switch (opt) {
		case 'e':
		enabled_escapes = 1;
		break;

		case 'E':
		enabled_escapes = 0;
		break;

		case 'n':
		write_newline = 0;
		break;
			
		default:
		printf("invalid option: ");
		printf("%s",argv[optind-1]);
		printf("\n HELP: echo \n");
		printf("    [-n] - do not output the trailing newline\n");
		printf("    [-e] - enable interpretation of backslash escapes\n");
		printf("    [-E] - disable interpretation of backslash escapes\n");
		exit(EXIT_FAILURE);

		break;
		}
	}

	/* выполняется если ,была указана опция -е */
	if (enabled_escapes == 1)
		do_echo_with_escapes(optind,argc,argv);
	else
		do_echo(optind,argc,argv);

	if ( write_newline == 1) printf("\n");

	exit(EXIT_SUCCESS);
}

// эту функцию я создала для печати слов без учета спец команд \\n \\t и т.д.
void do_echo(int optind, int argc, char *argv[] )
{
	int i;
	for (i = optind; i < argc; i++) {
		if (i == (argc - 1)) 
			printf("%s", argv[i]);
		else
			printf("%s ", argv[i]); 
	}
}

// эту функцию я создала для печати слов с учетом спец команд \\n \\t и т.д.c
void do_echo_with_escapes(int optind,int argc, char *argv[] )
{
	int i;
	int end_echo;
	end_echo = 0;
	char *c;
	for (i = optind; i < argc; i++) {
		c = argv[i];

		while (*c) {
			if (*c == '\\') {
				if (end_echo == 1) break;
				c++;

				switch(*c) {
				case '\\':
				printf("\\"); 	/* \\     backslash */
				break;
 
				case 'a':
				printf("\a"); 	/* \a     alert (BEL) */
				break;

				case 'b': 
				printf("\b"); 	/* \b     backspace */
				break;

				case 'c':
				end_echo = 1;	/* \c     produce no further output*/
				write_newline = 0;
				break;

				case 'f':
				printf("\f");	/* \f     form feed */
				break;

				case 'n':
				printf("\n");	/*   \n     new line */
				break;

				case 'r':
				printf("\r");	/*   \r     carriage return */
				break;

				case 't':
				printf("\t ");	/*  \t     horizontal tab */
				break;

				case 'v':
				printf("\v");	/*  \v     vertical tab */
				break;
				};
			} else {
				if (end_echo == 1) break;
				printf("%c",*c); 
			} 
			c++;
		} 

		if (i != argc-1) printf(" "); 
	} 
}






